#include <SDL.h>
#include "Kempston.h"

static Uint8 _kempston_state = 0x00;
static Uint8 _bad_input = 0x00;

Uint8 _kempston_map_button(SDL_Keysym key) {
	switch (key.sym) {
	case SDLK_UP: return KEMPSTON_UP;
	case SDLK_DOWN: return KEMPSTON_DOWN;
	case SDLK_LEFT: return KEMPSTON_LEFT;
	case SDLK_RIGHT: return KEMPSTON_RIGHT;
	case SDLK_LCTRL: return KEMPSTON_FIRE;

	default: return 0;
	}
}

void kempston_start() {

}

void kempston_destroy() {

}

Uint8 kempston_read8(Uint16 address) {
	switch (address & 0xFF) {
	case 0x1F: return _kempston_state;
	default: return _bad_input;
	}
}

Uint8 kempston_is_supported_address(Uint16 address) {
	switch (address & 0xFF) {
	case 0x1F:
		return 1;
	default: return 0;
	}
}

void kempston_keyup(SDL_Keysym key) {
	Uint8 button = _kempston_map_button(key);
	
	_kempston_state &= ~button;
}

void kempston_keydown(SDL_Keysym key) {
	Uint8 button = _kempston_map_button(key);

	_kempston_state |= button;
}
